﻿©Fluke                                                      MET/CAL Procedure
=============================================================================
INSTRUMENT:            Sub Tek RSA3000 Identification IEEE
INSTRUMENT:            Sub Tek RSA3000 Reset IEEE
INSTRUMENT:            Sub Tek RSA3000 Setup IEEE
INSTRUMENT:            Sub Tek RSA3000 Measure IEEE
DATE:                  2010-06-30 09:11:37
AUTHOR:                Fluke
REVISION:              $Revision: 2619 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       5
NUMBER OF LINES:       345
CONFIGURATION:         Tektronix RSA3308A
=============================================================================
#
#  Procedure Author:
#        ZY
#
#  Model(s) Covered:
#        RSA 3303A, RSA 3308A, RSA 3303B, RSA 3308B
#
#  Compatibility:
#        MET/CAL 7.20 SP1 (7.20x) or later
#
#  Subprocedures:
#        None
#
#  Required Files:
#        None
#
#  Additional Equipment Required:
#        None
#
#  This procedure is intended for use with MET/CAL® calibration software;
#  the terms and conditions set forth in your MET/CAL license apply to this
#  procedure.
#
#  Due to Fluke's policy of continuously updating our products, this procedure
#  may contain minor differences in methods used and/or specifications to
#  those found in the manual or other documentation. While every effort has
#  been made to ensure that this procedure is accurate, Fluke cannot be held
#  responsible for the consequences of error or omissions found within this
#  procedure.
#
#  The copyright in this procedure is owned by Fluke Corporation.
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON

  1.001  JMPL         ID                           PSUBI("Identification")
  1.002  JMPL         RESET                        PSUBI("Reset")
  1.003  JMPL         SETUP                        PSUBI("Setup")
  1.004  JMPL         MEASURE                      PSUBI("Measure")
  1.005  DISP         Subprocedure not found!
  1.006  END

  1.007  EVAL   Increment step number

# =============== Sub Tek RSA3000 Identification IEEE ======================

  2.001  LABEL        ID

# Identification query.
  2.002  IEEE2        [@RSA3000]*IDN?[I$]
  2.003  MATH         @RSA3000_Manufacturer = FLD(MEM2, 1, ",")
  2.004  MATH         @RSA3000_ModelNum     = FLD(MEM2, 2, ",")
  2.005  MATH         @RSA3000_SerialNum    = FLD(MEM2, 3, ",")
  2.006  MATH         @RSA3000_FirmwareRev  = FLD(MEM2, 4, ",")

  2.007  MATH         L[1] = ZCMPI(@RSA3000_Manufacturer, "TEKTRONIX")
  2.008  MATH         L[2] = ZCMPI(@RSA3000_ModelNum, "RSA3303A")
  2.009  MATH         L[2] = ZCMPI(@RSA3000_ModelNum, "RSA3303B") || L[2]
  2.010  MATH         L[2] = ZCMPI(@RSA3000_ModelNum, "RSA3308A") || L[2]
  2.011  MATH         L[2] = ZCMPI(@RSA3000_ModelNum, "RSA3308B") || L[2]

  2.012  MATH         @Error = NOT(L[1]) || NOT(L[2])

  2.013  IF           @Error
  2.014  DISP         User-configured Instrument:
  2.014  DISP
  2.014  DISP         [32][V @RSA3000_Manufacturer] [V @RSA3000_ModelNum]
  2.014  DISP
  2.014  DISP         with alias "3000" is not a Tektronix RSA 3000 Series.
  2.015  ENDIF

  2.016  END

  2.017  EVAL   Increment step number

# =============== Sub Tek RSA3000 Reset IEEE ===============================

  3.001  LABEL        RESET
  3.002  IEEE2        [@RSA3000]*RST

  3.003  END


  3.004  EVAL   Increment step number

# =============== Sub Tek RSA3000 Setup IEEE ===============================

  4.001  LABEL        SETUP

# Initialize option flags to zero.
  4.002  MATH         @Opt_1A = 0
  4.003  MATH         @Opt_L5 = 0
  4.004  MATH         @Opt_02 = 0
  4.005  MATH         @Opt_03 = 0
  4.006  MATH         @Opt_10 = 0
  4.007  MATH         @Opt_21 = 0
  4.008  MATH         @Opt_24 = 0
  4.009  MATH         @Opt_25 = 0
  4.010  MATH         @Opt_26 = 0
  4.011  MATH         @Opt_28 = 0
  4.012  MATH         @Opt_30 = 0
  4.013  MATH         @Opt_40 = 0
  4.014  MATH         @Opt_C3 = 0
  4.015  MATH         @Opt_C5 = 0
  4.016  MATH         @Opt_D1 = 0
  4.017  MATH         @Opt_D3 = 0
  4.018  MATH         @Opt_D5 = 0
  4.019  MATH         @Opt_R3 = 0
  4.020  MATH         @Opt_R5 = 0

# Check the option installed.
  4.021  IEEE2        [@RSA3000]*OPT?[I$]
  4.022  MATH         Field = 1
  4.023  MATH         Opt = FLD(MEM2, Field, ",")

  4.024  WHILE        NOT(EMPTY(Opt))

  4.025  IF           ZCMP(Opt, "1A")
  4.026  MATH         @Opt_1A = 1
  4.027  ELSEIF       ZCMP(Opt, "L5")
  4.028  MATH         @Opt_L5 = 1
  4.029  ELSEIF       ZCMP(Opt, "02")
  4.030  MATH         @Opt_02 = 1
  4.031  ELSEIF       ZCMP(Opt, "03")
  4.032  MATH         @Opt_03 = 1
  4.033  ELSEIF       ZCMP(Opt, "10")
  4.034  MATH         @Opt_10 = 1
  4.035  ELSEIF       ZCMP(Opt, "21")
  4.036  MATH         @Opt_21 = 1
  4.037  ELSEIF       ZCMP(Opt, "24")
  4.038  MATH         @Opt_24 = 1
  4.039  ELSEIF       ZCMP(Opt, "25")
  4.040  MATH         @Opt_25 = 1
  4.041  ELSEIF       ZCMP(Opt, "26")
  4.042  MATH         @Opt_26 = 1
  4.043  ELSEIF       ZCMP(Opt, "28")
  4.044  MATH         @Opt_28 = 1
  4.045  ELSEIF       ZCMP(Opt, "30")
  4.046  MATH         @Opt_30 = 1
  4.047  ELSEIF       ZCMP(Opt, "40")
  4.048  MATH         @Opt_40 = 1
  4.049  ELSEIF       ZCMP(Opt, "C3")
  4.050  MATH         @Opt_C3 = 1
  4.051  ELSEIF       ZCMP(Opt, "C5")
  4.052  MATH         @Opt_C5 = 1
  4.053  ELSEIF       ZCMP(Opt, "D1")
  4.054  MATH         @Opt_D1 = 1
  4.055  ELSEIF       ZCMP(Opt, "D3")
  4.056  MATH         @Opt_D3 = 1
  4.057  ELSEIF       ZCMP(Opt, "D5")
  4.058  MATH         @Opt_D5 = 1
  4.059  ELSEIF       ZCMP(Opt, "R3")
  4.060  MATH         @Opt_R3 = 1
  4.061  ELSEIF       ZCMP(Opt, "R5")
  4.062  MATH         @Opt_R5 = 1
  4.063  ENDIF

  4.064  MATH         Field = Field + 1
  4.065  MATH         Opt = FLD(MEM2, Field, ",")
  4.066  ENDW

# Set the measurement mode incorporated in the analyzer.
# The following table lists the mode names and their meanings:
#      Mnemonic      Meaning
#      ----------------------------------------------------------
#      SANORMAL      Normal spectrum analysis
#      SASGRAM       Spectrum analysis with spectrogram
#      SARTIME       Real-time spectrum analysis
#      DEMADEM       Analog modulation analysis (Option 21 only)
#      TIMCCDF       CCDF analysis
#      TIMTRAN       Time characteristic analysis

  4.067  IF           ZCMPI(@RSA3000_InitCmd, "SANORMAL")
  4.068  IEEE2        [@RSA3000]INST:SEL "SANORMAL"

  4.069  ELSEIF       ZCMPI(@RSA3000_InitCmd, "SASGRAM")
  4.070  IEEE2        [@RSA3000]INST:SEL "SASGRAM"

  4.071  ELSEIF       ZCMPI(@RSA3000_InitCmd, "SARTIME")
  4.072  IEEE2        [@RSA3000]INST:SEL "SARTIME"

  4.073  ELSEIF       ZCMPI(@RSA3000_InitCmd, "DEMADEM")

  4.074  IF           @Opt_21 == 1
  4.075  IEEE2        [@RSA3000]INST:SEL "DEMADEM"
  4.076  ELSE
  4.077  DISP         Option 21 must be installed!
  4.078  ENDIF

  4.079  ELSEIF       ZCMPI(@RSA3000_InitCmd, "TIMCCDF")
  4.080  IEEE2        [@RSA3000]INST:SEL "TIMCCDF"

  4.081  ELSEIF       ZCMPI(@RSA3000_InitCmd, "TIMTRAN")
  4.082  IEEE2        [@RSA3000]INST:SEL "TIMTRAN"

  4.083  ENDIF

# Set the reference level.
  4.084  IEEE2        [@RSA3000]INP:MLEV [V @RSA3000_RefLevel]

# Set the trace1 or trace2 mode.

  4.085  MATH         TraceCmd = "TRACE" & @RSA3000_TraceNum & ":MODE "
  4.086  MATH         TraceCmd = TraceCmd & @RSA3000_TraceMode
  4.087  IEEE2        [@RSA3000][V TraceCmd]

# Set data acquisition mode.
  4.088  IF           ZCMPI(@RSA3000_Acq, "1")
  4.089  IEEE2        [@RSA3000][T100000]INIT:CONT ON
  4.090  ELSE
  4.091  IEEE2        [@RSA3000][T100000]INIT:CONT OFF
  4.092  ENDIF

  4.093  END

  4.094  EVAL   Increment step number

# =============== Sub Tek RSA3000 Measure IEEE ==================

  5.001  LABEL        MEASURE

# Set the acquisition mode on.
  5.002  IEEE2        [@RSA3000][T100000]INIT:CONT ON

# Peak search function.
  5.003  IF           ZCMPI(@RSA3000_Func, "PeakSearch")

  5.004  IF           @RSA3000_CentFreq < 1E+3
  5.005  MATH         CentFreq = @RSA3000_CentFreq & "HZ"
  5.006  ELSEIF       @RSA3000_CentFreq >= 1E+3 && @RSA3000_CentFreq < 1E+6
  5.007  MATH         CentFreq = @RSA3000_CentFreq / 1E+3
  5.008  MATH         CentFreq = CentFreq & "KHZ"
  5.009  ELSEIF       @RSA3000_CentFreq >= 1E+6 && @RSA3000_CentFreq < 1E+9
  5.010  MATH         CentFreq = @RSA3000_CentFreq / 1E+6
  5.011  MATH         CentFreq = CentFreq & "MHZ"
  5.012  ELSEIF       @RSA3000_CentFreq >= 1E+9
  5.013  MATH         CentFreq = @RSA3000_CentFreq / 1E+9
  5.014  MATH         CentFreq = CentFreq & "GHZ"
  5.015  ENDIF

  5.016  IF           @RSA3000_Span < 1E+3
  5.017  MATH         SpanCmd = @RSA3000_Span & "HZ"
  5.018  ELSEIF       @RSA3000_Span >= 1E+3 && @RSA3000_Span < 1E+6
  5.019  MATH         Span = @RSA3000_Span / 1E+3
  5.020  MATH         SpanCmd = Span & "KHZ"
  5.021  ELSEIF       @RSA3000_Span >= 1E+6 && @RSA3000_Span < 1E+9
  5.022  MATH         Span = @RSA3000_Span / 1E+6
  5.023  MATH         SpanCmd = Span & "MHZ"
  5.024  ELSEIF       @RSA3000_Span >= 1E+9
  5.025  MATH         Span = @RSA3000_Span / 1E+9
  5.026  MATH         SpanCmd = Span & "GHZ"
  5.027  ENDIF

  5.028  IF           @RSA3000_BandRes < 1E+3
  5.029  MATH         BandRes = @RSA3000_BandRes & "HZ"
  5.030  ELSEIF       @RSA3000_BandRes >= 1E+3 && @RSA3000_BandRes < 1E+6
  5.031  MATH         BandRes = @RSA3000_BandRes / 1E+3
  5.032  MATH         BandRes = BandRes & "KHz"
  5.033  ELSEIF       @RSA3000_BandRes >= 1E+6 && @RSA3000_BandRes < 1E+9
  5.034  MATH         BandRes = @RSA3000_BandRes / 1E+6
  5.035  MATH         BandRes = BandRes & "MHz"
  5.036  ELSEIF       @RSA3000_BandRes >= 1E+9
  5.037  MATH         BandRes = @RSA3000_BandRes / 1E+9
  5.038  MATH         BandRes = BandRes & "GHz"
  5.039  ENDIF

  5.040  MATH         CentFreqCmdStr = "FREQ:CENT " & CentFreq
  5.041  MATH         SpanCmdStr = "FREQ:SPAN " & SpanCmd
  5.042  MATH         BandResCmdStr = "SPEC:BAND:RES " & BandRes
  5.043  MATH         AvgCountCmd = "TRAC1:AVER:COUN " & @RSA3000_AvgCount

  5.044  IEEE2        [@RSA3000]INP:MLEV [V @RSA3000_RefLevel]
  5.045  IEEE2        [@RSA3000][V CentFreqCmdStr]
  5.046  IEEE2        [@RSA3000][V SpanCmdStr]
  5.047  IEEE2        [@RSA3000]SPEC:BAND:AUTO OFF
  5.048  IEEE2        [@RSA3000][V BandResCmdStr]
  5.049  IEEE2        [@RSA3000][V AvgCountCmd]
  5.050  IEEE2        [@RSA3000][T100000]INIT:CONT OFF
  5.051  IEEE2        [@RSA3000]CALC1:MARK1:PTHR 0MHZ
  5.052  IEEE2        [@RSA3000]CALC1:MARK1:MAX
  5.053  IEEE2        [@RSA3000]CALC1:MARK1:Y?[I]
  5.054  MATH         @RSA3000_PkAmp = MEM
  5.055  IEEE2        [@RSA3000]CALC1:MARK1:X?[I]
  5.056  MATH         @RSA3000_PkFreq = MEM


# Harmonic measurement function.
  5.057  ELSEIF       ZCMPI(@RSA3000_Func, "Harmonic")

  5.058  IF           @RSA3000_HarmFreqSet < 1E+3
  5.059  MATH         FreqVal = @RSA3000_HarmFreqSet & "HZ"
  5.060  ELSEIF       @RSA3000_HarmFreqSet>=1E+3 && @RSA3000_HarmFreqSet<1E+6
  5.061  MATH         HarmFreq = @RSA3000_HarmFreqSet / 1E+3
  5.062  MATH         FreqVal = HarmFreq & "KHZ"
  5.063  ELSEIF       @RSA3000_HarmFreqSet>=1E+6 && @RSA3000_HarmFreqSet<1E+9
  5.064  MATH         HarmFreq = @RSA3000_HarmFreqSet / 1E+6
  5.065  MATH         FreqVal = HarmFreq & "MHZ"
  5.066  ELSEIF       @RSA3000_HarmFreqSet >= 1E+9
  5.067  MATH         HarmFreq = @RSA3000_HarmFreqSet / 1E+9
  5.068  MATH         FreqVal = HarmFreq & "GHZ"
  5.069  ELSE
  5.070  DISP         Wrong harmonic frequency setting!
  5.071  END
  5.072  ENDIF

  5.073  MATH         CmdStr = "FREQ:CENT " & FreqVal

  5.074  IEEE2        [@RSA3000][V CmdStr]
  5.075  IEEE2        [@RSA3000]INIT:CONT OFF
  5.076  IEEE2        [@RSA3000]INIT
  5.077  IEEE2        [@RSA3000]CALC1:MARK1:PTHR 0MHZ
  5.078  IEEE2        [@RSA3000]CALC1:MARK1:MAX
  5.079  IEEE2        [@RSA3000]CALC1:MARK1:Y?[I]
  5.080  MATH         @RSA3000_HarmAmp = MEM
  5.081  IEEE2        [@RSA3000]CALC1:MARK1:X?[I]
  5.082  MATH         @RSA3000_HarmFreq = MEM

# Next peak value search function.
  5.083  ELSEIF       ZCMPI(@RSA3000_Func, "NextPeak")
  5.084  IEEE2        [@RSA3000]CALC1:MARK1:PEAK:LOW
  5.085  IEEE2        [@RSA3000]CALC1:MARK1:Y?[I]
  5.086  MATH         @RSA3000_NtPkAmp = MEM
  5.087  IEEE2        [@RSA3000]CALC1:MARK1:X?[I]
  5.088  MATH         @RSA3000_NtPkFreq = MEM

  5.089  ENDIF

  5.090  END
